<template>
	<section class="FieldsViewMap">
		<mgl-map
			:markers="markers"
			:controls="controls"
			:zoom="mapOptions.zoom"
			:center="mapOptions.center"
			tileset="satellite-streets-v11"
		/>
	</section>
</template>

<script lang="ts">
import { defineComponent, computed } from '@vue/composition-api';
import MglMap from '@/components/map/MglMap.vue';
import { ControlTypes } from '@/components/map/mglUtils';
import { FieldRow } from '@/store/modules/fieldsView/utils';
import { getMapOptionsForFieldsView } from '@/utils/mapFetching';

export default defineComponent({
	components: {
		MglMap,
	},
	setup(_, { root }) {
		const areas = root.$store.getters['resources/getAreas'];
		const mapOptions = getMapOptionsForFieldsView(areas);

		const markers = computed(() => {
			const fieldRows: FieldRow[] = root.$store.getters['fieldsView/getFieldRows'];
			return fieldRows.map((fieldRow) => fieldRow.markerConfig).filter((markerConfig) => markerConfig.lngLat !== null);
		});

		return {
			markers,
			controls: [ControlTypes.Geolocate],
			mapOptions,
		};
	},
});
</script>

<style>
.FieldsViewMap {
	display: flex;
	align-items: center;
	justify-content: center;
	height: 100%;
	width: 100%;
}

.FieldsViewMap .map {
	width: 100%;
	height: 100%;
}

.MapPopup-fieldInfo {
	width: 200px;
}

.MapPopup-fieldInfo a {
	text-decoration: none;
}

.MapPopup-fieldInfo .text-overline {
	line-height: 1.6rem !important;
}
</style>
